package cz.majner.chata.nasechata;


import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.AsyncTask;
import android.preference.PreferenceManager;
import android.widget.Toast;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.URL;

import javax.net.ssl.HttpsURLConnection;




    public class ChataRemoteRequest extends AsyncTask<String, Void, String> {

        public static final String NOTIFICATION = "cz.majner.chata.nasechata.CHATA_REMOTE_REQUEST";
        private Context mContext;
        private String mAction;
        private Long mCommandID;
        SharedPreferences preferences;


        public ChataRemoteRequest(Context context, String sender, Long commandID)
        {
            mContext = context;
            mAction = sender;
            mCommandID = commandID;
            //mClient = new DefaultHttpClient();
        }

        @Override
        protected String doInBackground(String... parametry) {
            String vysledek;


            try {
                Intent intent1=new Intent(NOTIFICATION);
                intent1.putExtra("button_status", "false");
                mContext.sendBroadcast(intent1);

                preferences = PreferenceManager.getDefaultSharedPreferences(mContext);
                preferences.edit().putBoolean("buttons", false).apply();
                //editor.commit();

                URL url = new URL(parametry[0]);
                HttpsURLConnection conn = (HttpsURLConnection) url.openConnection();
                conn.setReadTimeout(10000 /* milliseconds */);
                conn.setConnectTimeout(15000 /* milliseconds */);
                conn.setRequestMethod("POST");
                conn.setDoInput(true);
                conn.setDoOutput(true);

                OutputStream os = conn.getOutputStream();
                BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(os, "UTF-8"));
                writer.write(parametry[1]);
                writer.flush();
                writer.close();
                os.close();

                conn.connect();
                //int responseCode = conn.getResponseCode();

                try {
                    InputStream is = conn.getInputStream();

                    BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(is));

                    int charRead;
                    char[] buffer = new char[1024];
                    StringBuilder stringBuffer = new StringBuilder();
                    while ((charRead = bufferedReader.read(buffer)) > 0) {
                        stringBuffer.append(buffer, 0, charRead);
                    }

                    vysledek = stringBuffer.toString();
                    is.close();

                } catch (Exception e) {
                    vysledek = "FAILED1";
                }
                finally{
                    conn.disconnect();
                }
            } catch (Exception e) {
                // we cannot do anything about that : network may be temporarily down
                //Log.d(MY_TAG, "HTTP request failed");
                vysledek = "FAILED2";
            }
            return vysledek;
        }

        @Override
        protected void onPostExecute(String vysledek) {

            preferences = PreferenceManager.getDefaultSharedPreferences(mContext);
            preferences.edit().putBoolean("buttons", true).apply();
            preferences.edit().putString("vysledek."+mAction, vysledek).apply();
            preferences.edit().putLong("commandID."+mAction, mCommandID).apply();

            Intent intent2=new Intent(NOTIFICATION+"."+mAction);
            intent2.putExtra("vysledek",vysledek);
            mContext.sendBroadcast(intent2);

            Intent intent3 = new Intent(NOTIFICATION);
            intent3.putExtra("button_status", "true");
            mContext.sendBroadcast(intent3);


        }
    }

