package cz.majner.chata.nasechata;


import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.SharedPreferences;
import android.graphics.Color;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.Uri;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.support.v4.app.Fragment;
import android.text.Html;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.TextView;

import java.text.DateFormat;
import java.util.Date;

//import android.widget.Toast;


public class FragmentPocasi extends Fragment {

    private final static String CONNECTIVITY = "android.net.conn.CONNECTIVITY_CHANGE";
    public static final String NOTIFICATION = "cz.majner.chata.nasechata.CHATA_REMOTE_REQUEST";
    private ConnectivityManager cm;
    private TextView popisPocasiInternetStav, textViewPocasiStav,
            tvOutTeplotaVlhkost, tvOutTlak, tvVitr, tvSrazky,
            tvInObyvak, tvInPredsin, tvInKoupelna, tvInLoznice, tvInSklep, tvInPuda,
            tvInServer, tvZdroj,
            tvTimestampWS3, tvTimestampWS8, tvTimestampQuido, tvTimestampWD;
    private Button buttonPocasiStav;
    SharedPreferences preferences;


    private BroadcastReceiver receiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            String action = intent.getAction();
            if (action.equals(CONNECTIVITY)) {
                updateNetworkStatus();
            }
            if (action.equals(NOTIFICATION)) {
                String button_status = intent.getStringExtra("button_status");
                if (button_status.equals("false")) {
                    nastavPocasiButtony(false);
                }
                if (button_status.equals("true")) {
                    nastavPocasiButtony(true);
                }
                //buttonOdeslat.setEnabled(true);
            }
            if (action.equals(NOTIFICATION + ".Pocasi")) {
                String vysledek = intent.getStringExtra("vysledek");
                zpracujPocasiVysledek(vysledek);

            }

        }
    };


    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {

        super.onCreateView(inflater, container, savedInstanceState);
        //Toast.makeText(getActivity(), "CreateView",Toast.LENGTH_SHORT).show();


        View view = inflater.inflate(R.layout.fragment_pocasi, container, false);

        popisPocasiInternetStav = (TextView) view.findViewById(R.id.popisPocasiInternetStav);
        textViewPocasiStav = (TextView) view.findViewById(R.id.textViewPocasiStav);
        buttonPocasiStav = (Button) view.findViewById(R.id.buttonPocasiStav);
        tvOutTeplotaVlhkost = (TextView) view.findViewById(R.id.tvOutTeplotaVlhkost);
        tvOutTlak = (TextView) view.findViewById(R.id.tvOutTlak);
        tvVitr = (TextView) view.findViewById(R.id.tvVitr);
        tvSrazky = (TextView) view.findViewById(R.id.tvSrazky);
        tvInObyvak = (TextView) view.findViewById(R.id.tvInObyvak);
        tvInPredsin = (TextView) view.findViewById(R.id.tvInPredsin);
        tvInKoupelna = (TextView) view.findViewById(R.id.tvInKoupelna);
        tvInLoznice = (TextView) view.findViewById(R.id.tvInLoznice);
        tvInSklep = (TextView) view.findViewById(R.id.tvInSklep);
        tvInPuda = (TextView) view.findViewById(R.id.tvInPuda);
        tvInServer = (TextView) view.findViewById(R.id.tvInServer);
        tvZdroj = (TextView) view.findViewById(R.id.tvZdroj);
        tvTimestampWS3 = (TextView) view.findViewById(R.id.tvTimestampWS3);
        tvTimestampWS8 = (TextView) view.findViewById(R.id.tvTimestampWS8);
        tvTimestampQuido = (TextView) view.findViewById(R.id.tvTimestampQuido);
        tvTimestampWD = (TextView) view.findViewById(R.id.tvTimestampWD);

        buttonPocasiStav.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                // Do something in response to button click
                textViewPocasiStav.setText("Aktualizuji stav...");

                Uri.Builder builder = new Uri.Builder();
                builder.appendQueryParameter("prikaz", "SQL INFO");
                preferences = PreferenceManager.getDefaultSharedPreferences(getActivity());
                builder.appendQueryParameter("pocet", preferences.getString("pref_edit_max_history", "5"))
                        .appendQueryParameter("auth_login", preferences.getString("pref_edit_url_name", "guest"))
                        .appendQueryParameter("auth_heslo", preferences.getString("pref_edit_url_heslo", "guest"));
                String query = builder.build().getEncodedQuery();
                Long timestampPocasi = System.currentTimeMillis();
                preferences.edit().putLong("timestampPocasi", timestampPocasi).apply();
                preferences.edit().putBoolean("progressPocasi", true).apply();
                new ChataRemoteRequest(getActivity(), "Pocasi", timestampPocasi).execute("https://chata.majner.cz/remote/remote.php", query);
            }
        });

        return view;
    }

    @Override
    public void onResume() {
        super.onResume();
        //Boolean butt=preferences.getBoolean("buttons", true);
        //String toustik= "Reason:" + PocasiTerminateReason + "\n"+progressPocasi.toString()+ "\n"+butt.toString()+ "\n"+commandID+ "="+ timestampPocasi+ "\n"+vysledek;
        //Toast.makeText(getActivity(), "resume", Toast.LENGTH_SHORT).show();

        getActivity().registerReceiver(receiver, new IntentFilter(NOTIFICATION));
        getActivity().registerReceiver(receiver, new IntentFilter(NOTIFICATION + ".Pocasi"));
        getActivity().registerReceiver(receiver, new IntentFilter(CONNECTIVITY));
        cm = (ConnectivityManager) getActivity().getSystemService(Context.CONNECTIVITY_SERVICE);
        updateNetworkStatus();

        preferences = PreferenceManager.getDefaultSharedPreferences(getActivity());

        obnovStavPocasiViewPref();
        Long commandID = preferences.getLong("commandID.Pocasi", 0);
        Long timestampPocasi = preferences.getLong("timestampPocasi", 1);
        String vysledek = preferences.getString("vysledek.Pocasi", "");
        Boolean progressPocasi = preferences.getBoolean("progressPocasi", false);
        if (progressPocasi && commandID.equals(timestampPocasi)) {
            zpracujPocasiVysledek(vysledek);
            //Toast.makeText(getActivity(),"zpracovavam", Toast.LENGTH_LONG).show();
        }

    }


    @Override
    public void onDestroy() {
        super.onDestroy();
        //getActivity().unregisterReceiver(receiver);
        //Toast.makeText(getActivity(), "Destroy",Toast.LENGTH_SHORT).show();
    }

    public void onPause() {
        super.onPause();
        //Toast.makeText(getActivity(), "Pause",Toast.LENGTH_SHORT).show();
        getActivity().unregisterReceiver(receiver);
        ulozStavPocasiViewPref();
    }


    private void updateNetworkStatus() {
        if (cm != null) {
            NetworkInfo activeNetwork = cm.getActiveNetworkInfo();
            if (activeNetwork != null && activeNetwork.isAvailable() && activeNetwork.isConnected()) {
                popisPocasiInternetStav.setText("připojeno.");
                popisPocasiInternetStav.setTextColor(textViewPocasiStav.getTextColors());
            } else {
                popisPocasiInternetStav.setText("nepřipojeno.");
                popisPocasiInternetStav.setTextColor(Color.RED);
            }
        }
    }



    public void nastavPocasiButtony(Boolean pozadovanyStav) {
        buttonPocasiStav.setEnabled(pozadovanyStav);

    }


    public void ulozStavPocasiViewPref() {
        preferences = PreferenceManager.getDefaultSharedPreferences(getActivity());
        //stav aktualizace
        preferences.edit().putString("textViewPocasiStav", textViewPocasiStav.getText().toString()).apply();
        //WS3650IT
        preferences.edit().putString("tvOutTeplotaVlhkost", tvOutTeplotaVlhkost.getText().toString()).apply();
        preferences.edit().putString("tvOutTlak", tvOutTlak.getText().toString()).apply();
        preferences.edit().putString("tvVitr", tvVitr.getText().toString()).apply();
        preferences.edit().putString("tvSrazky", tvSrazky.getText().toString()).apply();
        preferences.edit().putString("tvInObyvak", tvInObyvak.getText().toString()).apply();
        preferences.edit().putString("tvInPredsin", tvInPredsin.getText().toString()).apply();
        preferences.edit().putString("tvInKoupelna", tvInKoupelna.getText().toString()).apply();
        preferences.edit().putString("tvInLoznice", tvInLoznice.getText().toString()).apply();
        preferences.edit().putString("tvInSklep", tvInSklep.getText().toString()).apply();
        preferences.edit().putString("tvInPuda", tvInPuda.getText().toString()).apply();
        preferences.edit().putString("tvInServer", tvInServer.getText().toString()).apply();
        preferences.edit().putString("tvZdroj", tvZdroj.getText().toString()).apply();
        preferences.edit().putString("tvTimestampWS3", tvTimestampWS3.getText().toString()).apply();
        preferences.edit().putString("tvTimestampWS8", tvTimestampWS8.getText().toString()).apply();
        preferences.edit().putString("tvTimestampQuido", tvTimestampQuido.getText().toString()).apply();
        preferences.edit().putString("tvTimestampWD", tvTimestampWD.getText().toString()).apply();


    }

    public void obnovStavPocasiViewPref() {
        preferences = PreferenceManager.getDefaultSharedPreferences(getActivity());
        //stav aktualizace
        textViewPocasiStav.setText(preferences.getString("textViewPocasiStav", "Neaktualizováno."));
        //WS3650IT
        tvOutTeplotaVlhkost.setText(preferences.getString("tvOutTeplotaVlhkost", "neznámé"));
        tvOutTlak.setText(preferences.getString("tvOutTlak", "neznámé"));
        tvVitr.setText(preferences.getString("tvVitr", "neznámé"));
        tvSrazky.setText(preferences.getString("tvSrazky", "neznámé"));
        tvInObyvak.setText(preferences.getString("tvInObyvak", "neznámé"));
        tvInPredsin.setText(preferences.getString("tvInPredsin", "neznámé"));
        tvInKoupelna.setText(preferences.getString("tvInKoupelna", "neznámé"));
        tvInLoznice.setText(preferences.getString("tvInLoznice", "neznámé"));
        tvInSklep.setText(preferences.getString("tvInSklep", "neznámé"));
        tvInPuda.setText(preferences.getString("tvInPuda", "neznámé"));
        tvInServer.setText(preferences.getString("tvInServer", "neznámé"));
        tvZdroj.setText(preferences.getString("tvZdroj", "neznámé"));
        tvTimestampWS3.setText(preferences.getString("tvTimestampWS3", "neznámé"));
        tvTimestampWS8.setText(preferences.getString("tvTimestampWS8", "neznámé"));
        tvTimestampQuido.setText(preferences.getString("tvTimestampQuido", "neznámé"));
        tvTimestampWD.setText(preferences.getString("tvTimestampWD", "neznámé"));


        //tlacitka
        Boolean butt=preferences.getBoolean("buttons", true);
        nastavPocasiButtony(butt);
    }

    public void zpracujPocasiVysledek (String vysledek) {
        preferences = PreferenceManager.getDefaultSharedPreferences(getActivity());
        //Toast.makeText(getActivity(), toustik, Toast.LENGTH_LONG).show();
        //info o stavu aktualizace
        Long timestampPocasi = preferences.getLong("timestampPocasi", 1);
        String currentDateandTime = DateFormat.getDateTimeInstance().format(new Date(timestampPocasi));
        textViewPocasiStav.setText("Stav k " + currentDateandTime + ".");

        if (vysledek.lastIndexOf("ID=") > 0) {
            Integer index3To = vysledek.indexOf("3To=") + ("3To=").length();
            String s3To = vysledek.substring(index3To, vysledek.indexOf("<BR>", index3To));
            Integer index3RHo = vysledek.indexOf("3RHo=") + ("3RHo=").length();
            String s3RHo = vysledek.substring(index3RHo, vysledek.indexOf("<BR>", index3RHo));
            Integer index3DP = vysledek.indexOf("3DP=") + ("3DP=").length();
            String s3DP = vysledek.substring(index3DP, vysledek.indexOf("<BR>", index3DP));
            tvOutTeplotaVlhkost.setText(Html.fromHtml(s3To + "<sup><small>o</small></sup>C, " + s3RHo + "%, pocitová " + s3DP + "<sup><small>o</small></sup>C"));
            //
            Integer index3RP = vysledek.indexOf("3RP=") + ("3RP=").length();
            String s3RP = vysledek.substring(index3RP, vysledek.indexOf("<BR>", index3RP));
            Integer index3AP = vysledek.indexOf("3AP=") + ("3AP=").length();
            String s3AP = vysledek.substring(index3AP, vysledek.indexOf("<BR>", index3AP));
            tvOutTlak.setText(Html.fromHtml("rel. " + s3RP + "hPa, " + "abs. " + s3AP + "hPa"));
            //


            Integer index8To2 = vysledek.indexOf("8To2=") + ("8To2=").length();
            String s8To2 = vysledek.substring(index8To2, vysledek.indexOf("<BR>", index8To2));
            Integer index8Ho2 = vysledek.indexOf("8Ho2=") + ("8Ho2=").length();
            String s8Ho2 = vysledek.substring(index8Ho2, vysledek.indexOf("<BR>", index8Ho2));
            tvInObyvak.setText(Html.fromHtml(s8To2 + "<sup><small>o</small></sup>C, " + s8Ho2 + "%"));
            //
            Integer index3Ti = vysledek.indexOf("3Ti=") + ("3Ti=").length();
            String s3Ti = vysledek.substring(index3Ti, vysledek.indexOf("<BR>", index3Ti));
            Integer index3RHi = vysledek.indexOf("3RHi=") + ("3RHi=").length();
            String s3RHi = vysledek.substring(index3RHi, vysledek.indexOf("<BR>", index3RHi));
            tvInPredsin.setText(Html.fromHtml(s3Ti + "<sup><small>o</small></sup>C, " + s3RHi + "%"));
            //
            Integer index8To1 = vysledek.indexOf("8To1=") + ("8To1=").length();
            String s8To1 = vysledek.substring(index8To1, vysledek.indexOf("<BR>", index8To1));
            Integer index8Ho1 = vysledek.indexOf("8Ho1=") + ("8Ho1=").length();
            String s8Ho1 = vysledek.substring(index8Ho1, vysledek.indexOf("<BR>", index8Ho1));
            tvInKoupelna.setText(Html.fromHtml(s8To1 + "<sup><small>o</small></sup>C, " + s8Ho1 + "%"));
            //
            Integer index8To3 = vysledek.indexOf("8To3=") + ("8To3=").length();
            String s8To3 = vysledek.substring(index8To3, vysledek.indexOf("<BR>", index8To3));
            Integer index8Ho3 = vysledek.indexOf("8Ho3=") + ("8Ho3=").length();
            String s8Ho3 = vysledek.substring(index8Ho3, vysledek.indexOf("<BR>", index8Ho3));
            tvInSklep.setText(Html.fromHtml(s8To3 + "<sup><small>o</small></sup>C, " + s8Ho3 + "%"));
            //


            Integer index3Date = vysledek.indexOf("3Date=") + ("3Date=").length();
            String s3Date = vysledek.substring(index3Date, vysledek.indexOf("<BR>", index3Date));
            Integer index3Time = vysledek.indexOf("3Time=") + ("3Time=").length();
            String s3Time = vysledek.substring(index3Time, vysledek.indexOf("<BR>", index3Time));
            tvTimestampWS3.setText(Html.fromHtml(s3Date + " " + s3Time));
            //
            Integer index8Date = vysledek.indexOf("8Date=") + ("8Date=").length();
            String s8Date = vysledek.substring(index8Date, vysledek.indexOf("<BR>", index8Date));
            Integer index8Time = vysledek.indexOf("8Time=") + ("8Time=").length();
            String s8Time = vysledek.substring(index8Time, vysledek.indexOf("<BR>", index8Time));
            tvTimestampWS8.setText(Html.fromHtml(s8Date + " " + s8Time));
            //
            Integer indexQDate = vysledek.indexOf("QDate=") + ("QDate=").length();
            String sQDate = vysledek.substring(indexQDate, vysledek.indexOf("<BR>", indexQDate));
            Integer indexQTime = vysledek.indexOf("QTime=") + ("QTime=").length();
            String sQTime = vysledek.substring(indexQTime, vysledek.indexOf("<BR>", indexQTime));
            tvTimestampQuido.setText(Html.fromHtml(sQDate + " " + sQTime));
            //
            Integer indexWDate = vysledek.indexOf("WDate=") + ("WDate=").length();
            String sWDate = vysledek.substring(indexWDate, vysledek.indexOf("<BR>", indexWDate));
            Integer indexWTime = vysledek.indexOf("WTime=") + ("WTime=").length();
            String sWTime = vysledek.substring(indexWTime, vysledek.indexOf("<BR>", indexWTime));
            tvTimestampWD.setText(Html.fromHtml(sWDate + " " + sWTime));
        }

        if (vysledek.contains("FAILED")) {
            textViewPocasiStav.setText( "Chyba komunikace se serverem!");
        }
        if (vysledek.contains("Neplatn")) {
            textViewPocasiStav.setText("Neplatná autorizace!");
        }
        preferences.edit().putBoolean("progressPocasi", false).apply();
    }

}