package cz.majner.chata.nasechata;


import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.SharedPreferences;
import android.graphics.Color;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.Uri;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.Spinner;
import android.widget.TextView;

public class FragmentScript extends Fragment {

    private final static String CONNECTIVITY = "android.net.conn.CONNECTIVITY_CHANGE";
    public static final String NOTIFICATION = "cz.majner.chata.nasechata.CHATA_REMOTE_REQUEST";
    private ConnectivityManager cm;
    private TextView textViewInternetStatusData, textViewInternetStatusPopis,textViewOdpoved;
    private String ZvolenyPrikaz;
    private Spinner spinnerPrikaz;
    private Button buttonOdeslat;
    SharedPreferences preferences;

    private BroadcastReceiver receiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            String action = intent.getAction();
            if (action.equals(CONNECTIVITY)) {
                updateNetworkStatus();
            }
            if (action.equals(NOTIFICATION)) {
                String button_status = intent.getStringExtra("button_status");
                if (button_status.equals("false")) {nastavScriptButtony(false);}
                if (button_status.equals("true")) {nastavScriptButtony(true);}
                //buttonOdeslat.setEnabled(true);
            }
            if (action.equals(NOTIFICATION+".SCRIPT")) {
                String vysledek = intent.getStringExtra("vysledek");
                zpracujScriptVysledek(vysledek);
                //buttonOdeslat.setEnabled(true);
            }

        }
    };



	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
			Bundle savedInstanceState) {
		// Get the view from fragmenttab1.xml


		View view = inflater.inflate(R.layout.fragment_script, container, false);


        textViewInternetStatusData = (TextView) view.findViewById(R.id.textViewInternetStatusData);
        textViewOdpoved = (TextView) view.findViewById(R.id.textViewOdpoved);
        textViewInternetStatusPopis = (TextView) view.findViewById(R.id.textViewInternetStatusPopis);
        spinnerPrikaz = (Spinner) view.findViewById(R.id.spinnerPrikaz);
        buttonOdeslat = (Button) view.findViewById(R.id.buttonQuidoVchodVyp);
        /*
        if (savedInstanceState != null)
        {
            obnovStavScriptView (savedInstanceState);
        }
        */

        buttonOdeslat.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                // Do something in response to button click

                //buttonOdeslat.setEnabled(false);
                textViewOdpoved.setText("Čekám na odpověď...");


                Uri.Builder builder = new Uri.Builder();
                ZvolenyPrikaz = String.valueOf(spinnerPrikaz.getSelectedItem());
                //poslat dotaz na server
                if (ZvolenyPrikaz.equals("ATH - ZTL")) {
                    builder.appendQueryParameter("prikaz", "ATH NASTAV");
                    builder.appendQueryParameter("aku_loznice", "ZTL");

                } else if (ZvolenyPrikaz.equals("ATH - VTL")) {
                    builder.appendQueryParameter("prikaz", "ATH NASTAV");
                    builder.appendQueryParameter("aku_loznice", "VTL");

                } else if (ZvolenyPrikaz.equals("ATH - TLV")) {
                    builder.appendQueryParameter("prikaz", "ATH NASTAV");
                    builder.appendQueryParameter("teplota_loznice", "TLV");

                } else if (ZvolenyPrikaz.equals("ATH - TLN")) {
                    builder.appendQueryParameter("prikaz", "ATH NASTAV");
                    builder.appendQueryParameter("teplota_loznice", "TLN");

                } else if (ZvolenyPrikaz.equals("ATH - ZAK")) {
                    builder.appendQueryParameter("prikaz", "ATH NASTAV");
                    builder.appendQueryParameter("aku_obyvak", "ZAK");

                } else if (ZvolenyPrikaz.equals("ATH - VAK")) {
                    builder.appendQueryParameter("prikaz", "ATH NASTAV");
                    builder.appendQueryParameter("aku_obyvak", "VAK");

                } else if (ZvolenyPrikaz.equals("ATH - TOV")) {
                    builder.appendQueryParameter("prikaz", "ATH NASTAV");
                    builder.appendQueryParameter("teplota_obyvak", "TOV");

                } else if (ZvolenyPrikaz.equals("ATH - TON")) {
                    builder.appendQueryParameter("prikaz", "ATH NASTAV");
                    builder.appendQueryParameter("teplota_obyvak", "TON");

                } else if (ZvolenyPrikaz.equals("ATH - ZBO")) {
                    builder.appendQueryParameter("prikaz", "ATH NASTAV");
                    builder.appendQueryParameter("bojler_koupelna", "ZBO");

                } else if (ZvolenyPrikaz.equals("ATH - VBO")) {
                    builder.appendQueryParameter("prikaz", "ATH NASTAV");
                    builder.appendQueryParameter("bojler_koupelna", "VBO");

                } else if (ZvolenyPrikaz.equals("ATH - ZTK")) {
                    builder.appendQueryParameter("prikaz", "ATH NASTAV");
                    builder.appendQueryParameter("topeni_koupelna", "ZTK");

                } else if (ZvolenyPrikaz.equals("ATH - VTK")) {
                    builder.appendQueryParameter("prikaz", "ATH NASTAV");
                    builder.appendQueryParameter("topeni_koupelna", "VTK");

                } else {
                    builder.appendQueryParameter("prikaz", ZvolenyPrikaz);

                }
                preferences = PreferenceManager.getDefaultSharedPreferences(getActivity());
                builder.appendQueryParameter("pocet", preferences.getString("pref_edit_max_history", "5"))
                        .appendQueryParameter("auth_login", preferences.getString("pref_edit_url_name", "guest"))
                        .appendQueryParameter("auth_heslo", preferences.getString("pref_edit_url_heslo", "guest"));
                String query = builder.build().getEncodedQuery();
                //TextView popSvetloVchod = (TextView) findViewById(R.id.popisekStavSvetloVchod);
                //popSvetloVchod.setText(query);
                Long timestampScript = System.currentTimeMillis();
                preferences.edit().putLong("timestampScript", timestampScript).apply();
                preferences.edit().putBoolean("progressScript", true).apply();

                new ChataRemoteRequest(getActivity(),"SCRIPT",timestampScript).execute("https://chata.majner.cz/remote/remote.php",query);


            }
        });


        return view;
	}

    @Override
    public void onResume() {
        super.onResume();
        //locationManager.removeUpdates(this);
        getActivity().registerReceiver(receiver, new IntentFilter(NOTIFICATION));
        getActivity().registerReceiver(receiver, new IntentFilter(NOTIFICATION+".SCRIPT"));
        getActivity().registerReceiver(receiver, new IntentFilter(CONNECTIVITY));
        cm = (ConnectivityManager) getActivity().getSystemService(Context.CONNECTIVITY_SERVICE);
        updateNetworkStatus();
        preferences = PreferenceManager.getDefaultSharedPreferences(getActivity());
        obnovStavScriptViewPref();
        Long commandID = preferences.getLong("commandID.SCRIPT", 0);
        Long timestampScript = preferences.getLong("timestampScript", 1);
        String vysledek = preferences.getString("vysledek.SCRIPT", "");
        Boolean progressScript = preferences.getBoolean("progressScript", false);
        //String toustik= progressScript.toString()+ "\n"+commandID+ "="+ timestampScript+ "\n"+vysledek;
        //Toast.makeText(getActivity(), toustik, Toast.LENGTH_LONG).show();
        //zpracujQuidoVysledek(vysledek);
        if (progressScript && commandID.equals(timestampScript)) {
            zpracujScriptVysledek(vysledek);
            //Toast.makeText(getActivity(), "ZPRACOVANO", Toast.LENGTH_LONG).show();

        }

    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        //getActivity().unregisterReceiver(receiver);
        //Toast.makeText(getActivity(), "Destroy",Toast.LENGTH_LONG).show();
        //removeStavQuidoPref();
        //preferences.edit().putString("QuidoTerminateReason", "onDestroy").apply();

    }

    @Override
    public void onPause() {
        super.onPause();
        //locationManager.removeUpdates(this);
        getActivity().unregisterReceiver(receiver);
        ulozStavScriptViewPref();
    }
/*
	@Override
	public void onSaveInstanceState(Bundle outState) {
		super.onSaveInstanceState(outState);
		//setUserVisibleHint(true);
        ulozStavScriptViewPref();

    }
*/
    private void updateNetworkStatus() {
        if (cm != null) {
            NetworkInfo activeNetwork = cm.getActiveNetworkInfo();
            if (activeNetwork != null && activeNetwork.isAvailable() && activeNetwork.isConnected()) {
                textViewInternetStatusData.setText("připojeno.");
                textViewInternetStatusData.setTextColor(textViewInternetStatusPopis.getTextColors());
                //nastavScriptButtony(true);
            } else {
                textViewInternetStatusData.setText("nepřipojeno.");
                textViewInternetStatusData.setTextColor(Color.RED);
                //nastavScriptButtony(false);
            }
        }

    }

    public void nastavScriptButtony(Boolean pozadovanyStav) {
        buttonOdeslat.setEnabled(pozadovanyStav);

    }

    public void ulozStavScriptViewPref() {
        //Bundle outState = new Bundle();
        preferences = PreferenceManager.getDefaultSharedPreferences(getActivity());
        //preferences.edit().putString("textViewInternetStatusData", textViewInternetStatusData.getText().toString()).apply();
        preferences.edit().putString("textViewOdpoved", textViewOdpoved.getText().toString()).apply();
       // preferences.edit().putString("textViewInternetStatusPopis", textViewInternetStatusPopis.getText().toString()).apply();
        preferences.edit().putInt("spinnerPrikaz", spinnerPrikaz.getSelectedItemPosition()).apply();
        //if (butony) {preferences.edit().putBoolean("buttons", buttonOdeslat.isEnabled()).apply();}

        /*
        outState.putString("textViewInternetStatusData", textViewInternetStatusData.getText().toString());
        outState.putString("textViewOdpoved", textViewOdpoved.getText().toString());
        outState.putString("textViewInternetStatusPopis",  textViewInternetStatusPopis.getText().toString());

        outState.putInt("spinnerPrikaz", spinnerPrikaz.getSelectedItemPosition());

        outState.putBoolean("buttonOdeslat", buttonOdeslat.isEnabled());
        */
    }

    public void obnovStavScriptViewPref() {
        //Bundle outState = new Bundle();
        preferences = PreferenceManager.getDefaultSharedPreferences(getActivity());
        //textViewInternetStatusData.setText(preferences.getString("textViewInternetStatusData", ""));
        textViewOdpoved.setText(preferences.getString("textViewOdpoved", "ODPOVĚĎ:"));
        //textViewInternetStatusPopis.setText(pref.getString("textViewInternetStatusPopis", ""));
        spinnerPrikaz.setSelection(preferences.getInt("spinnerPrikaz", 1));
        Boolean butt=preferences.getBoolean("buttons", true);

        nastavScriptButtony(butt);
         /*
        outState.putString("textViewInternetStatusData", textViewInternetStatusData.getText().toString());
        outState.putString("textViewOdpoved", textViewOdpoved.getText().toString());
        outState.putString("textViewInternetStatusPopis",  textViewInternetStatusPopis.getText().toString());
        outState.putInt("spinnerPrikaz", spinnerPrikaz.getSelectedItemPosition());
        outState.putBoolean("buttonOdeslat", buttonOdeslat.isEnabled());
        */
    }

    /*
    public void obnovStavScriptView ( Bundle savedInstanceState) {

        textViewInternetStatusData.setText(savedInstanceState.getString("textViewInternetStatusData"));
        textViewOdpoved.setText(savedInstanceState.getString("textViewOdpoved"));
        textViewInternetStatusPopis.setText(savedInstanceState.getString("textViewInternetStatusPopis"));
        spinnerPrikaz.setSelection(savedInstanceState.getInt("spinnerPrikaz"));
        buttonOdeslat.setEnabled(savedInstanceState.getBoolean("buttonOdeslat"));
    }
    */

    public void zpracujScriptVysledek (String vysledek) {
        preferences = PreferenceManager.getDefaultSharedPreferences(getActivity());
        textViewOdpoved.setText("ODPOVĚĎ:\n"+vysledek.replace("<BR>",""));

        //ulozStavScriptViewPref();
        preferences.edit().putBoolean("progressScript", false).apply();

    }

}
